/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package songview;

import java.util.ArrayList;
import javafx.beans.property.SimpleObjectProperty;
import javafx.beans.property.SimpleStringProperty;
import javafx.scene.image.Image;

/**
 *
 * @author klimczak
 */
public class SongCollection {
    
    //List to hold Songs
    private ArrayList<Song> list;
    //"Pointer"
    private int pointer;
    
    //Properies for Binding
    private SimpleStringProperty currentTitleProperty = new SimpleStringProperty();
    private SimpleObjectProperty<Image> currentCoverProperty = new SimpleObjectProperty<Image>();
    
    
    public SongCollection() {
        list = new ArrayList<Song>();
        pointer=-1;
    }
    
    public SimpleStringProperty getTitleProperty(){
        return currentTitleProperty;
    }
    
    public SimpleObjectProperty<Image> getCoverProperty(){
        return currentCoverProperty;
    }
    
    private void setSong(){
        Song currentSong=list.get(pointer);
        currentTitleProperty.set(currentSong.getTitle());
        currentCoverProperty.set(currentSong.getCover());
    }
    
    public void addSong(Song song) {
        list.add(song);
        if(pointer==-1) {
            pointer++;
            setSong();
        }
    }
    
    public void removeSong() {
        list.remove(pointer);
        pointer=0;
        setSong();
    }
    
    public void forward(){
        if(pointer>=list.size()-1)
              return;
        pointer++;
        setSong();
    }
    public void backward(){
        if(pointer==0)
              return;
        pointer--;
        setSong();
    }
}
